# include <p8q.h>

# if ! defined N
# define N 4
# endif /* ! defined N */

typedef int mat[N][N];

typedef enum {
  READ_PUBLIC_SMALL,
  READ_PUBLIC_LARGE,
  READ_PRIVATE,
  ASSERT_EQ
} matrix_iter_cb;

void
matrix_iter(mat a, mat b, matrix_iter_cb f)
{
  for ( int i = 0 ; i < N ; ++i )
  {
    verasco_unroll ( N );
    for ( int j = 0 ; j < N ; ++j )
    {
    verasco_unroll ( N );
      switch ( f ) {
      case READ_PUBLIC_SMALL:
        a[i][j] = read_public_int(0, 0xFF);
        break;
      case READ_PUBLIC_LARGE:
        a[i][j] = read_public_int(0, 0xFFFFFF);
        break;
      case READ_PRIVATE:
        a[i][j] = read_private_int(8);
        break;
      case ASSERT_EQ:
        assert ( a[i][j] == b[i][j] );
        break;
      }
    }
  }
}

/** o := a × b */
void
matrix_mul(mat o, mat a, mat b)
{
  for ( int i = 0 ; i < N ; ++i )
  {
    verasco_unroll ( N );
    for ( int j = 0 ; j < N ; ++j )
    {
    verasco_unroll ( N );
      o[i][j] = 0;
      for ( int k = 0 ; k < N ; ++k )
      {
        o[i][j] += a[i][k] * b[k][j];
      }
    }
  }
}

int
main(void)
{
  mat a, x, ax, b;
  matrix_iter(a, a, READ_PUBLIC_SMALL);
  matrix_iter(x, x, READ_PRIVATE);
  matrix_iter(b, b, READ_PUBLIC_LARGE);

  matrix_mul(ax, a, x);

  matrix_iter(ax, b, ASSERT_EQ);

  return 0;
}
