Require Import Utf8 Psatz ZArith.
Local Open Scope Z_scope.

(* Old large prime. Too large… *)
Definition old_large_prime_def (x: Z) :=
   let x2 := x * x in
   let x3 := x * x2 in
   let x4 := x2 * x2 in
  36 * x4 + 36 * x3 + 24 * x2 + 6 * x + 1.

Definition old_large_prime := Eval vm_compute in match old_large_prime_def (- (Z.shiftl 1 62 + Z.shiftl 1 55 + 1)) with Zpos p => p | _ => xH end.

(* Correct large prime.
let p =
  (* the EC group for Pinocchio has q elements *)
  let u = - bigint 7 * bigint 641 * bigint 15698303 * bigint 65982793
  let p = bigint 36 * u * u * u * u + bigint 36 * u * u * u + bigint 24 * u * u + bigint 6 * u + bigint 1
  let q = bigint 36 * u * u * u * u + bigint 36 * u * u * u + bigint 18 * u * u + bigint 6 * u + bigint 1
  q

val p = 16798108731015832284940804142231733909759579603404752749028378864165570215949
// 254 bits
*)

Definition large_prime := 16798108731015832284940804142231733909759579603404752749028378864165570215949%positive.

Remark large_prime_nz : Zpos large_prime ≠ 0. Proof. lia. Qed.
