{ stdenv, fetchFromGitHub, which, coq }:

stdenv.mkDerivation {

  name = "coq${coq.coq-version}-mathcomp-1.6.1";

  src = fetchFromGitHub {
    owner = "math-comp";
    repo = "math-comp";
    rev = "mathcomp-1.6.1";
    sha256 = "1ilw6vm4dlsdv9cd7kmf0vfrh2kkzr45wrqr8m37miy0byzr4p9i";
  };

  buildInputs = [ which coq coq.ocaml coq.camlp5 ];

  preBuild = ''
    patchShebangs etc/utils/ssrcoqdep
    cd mathcomp
  '';

  installPhase = ''
    make -f Makefile.coq COQLIB=$out/lib/coq/${coq.coq-version}/ install
  '';

}
